package com.kunzisoft.switchdatetimesample;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.kunzisoft.R;

import com.kunzisoft.switchdatetime.SwitchDateTimeDialogFragment;

import java.util.Date;

import switchdatetimepickerwrapper.switchdatetimepickerWrapper;

import anywheresoftware.b4a.BA;

public class Sample extends AppCompatActivity {

    private static final String TAG_DATETIME_FRAGMENT = "TAG_DATETIME_FRAGMENT";

    private static final String STATE_TEXTVIEW = "STATE_TEXTVIEW";
    private TextView textView;

    private SwitchDateTimeDialogFragment dateTimeFragment;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.activity_sample);

        //textView = (TextView) findViewById(R.id.textView);
        if (savedInstanceState != null) {
            // Restore value from saved state
            //textView.setText(savedInstanceState.getCharSequence(STATE_TEXTVIEW));
        }

        // Construct SwitchDateTimePicker
        dateTimeFragment = (SwitchDateTimeDialogFragment) getSupportFragmentManager().findFragmentByTag(TAG_DATETIME_FRAGMENT);
        if(dateTimeFragment == null) {
            dateTimeFragment = SwitchDateTimeDialogFragment.newInstance(
                    getString(R.string.label_datetime_dialog),
                    getString(R.string.positive_button_datetime_picker),
                    getString(R.string.negative_button_datetime_picker)
            );
        }
        // Assign values we want
        dateTimeFragment.setHour(0);
        dateTimeFragment.setMinute(20);
        // Set listener for get Date
        dateTimeFragment.setOnButtonClickListener(new SwitchDateTimeDialogFragment.OnButtonClickListener() {
            @Override
            public void onPositiveButtonClick(Date date) {
                //textView.setText(date.toString());
				int year = date.getYear()+ 1900;
				int month = date.getMonth() + 1;
				int day = date.getDate();
				int hour = date.getHours();
				int minute = date.getMinutes();
				String full_date = date.toString();
				
				if (switchdatetimepickerWrapper.ba.subExists(switchdatetimepickerWrapper.eventName + "_selected_date_time")) {
				  switchdatetimepickerWrapper.ba.raiseEventFromDifferentThread(this, null, 0, switchdatetimepickerWrapper.eventName + "_selected_date_time", true, new Object[] {year, month, day, hour, minute, full_date});
				}					
				
				
/* 				BA.Log("year = " + year);
				BA.Log("month = " + month);
				BA.Log("day = " + day);
				BA.Log("hour = " + hour);
				BA.Log("minute = " + minute);
				BA.Log("full date = " + date.toString());
 */				
				
				finish();
            }

            @Override
            public void onNegativeButtonClick(Date date) {
                //textView.setText("");
				if (switchdatetimepickerWrapper.ba.subExists(switchdatetimepickerWrapper.eventName + "_cancelled")) {
				  switchdatetimepickerWrapper.ba.raiseEventFromDifferentThread(this, null, 0, switchdatetimepickerWrapper.eventName + "_cancelled", true, new Object[0]);
				}						
				finish();
            }
        });

        //Button buttonView = (Button) findViewById(R.id.button);
        //buttonView.setOnClickListener(new View.OnClickListener() {
        //    @Override
        //    public void onClick(View view) {
                dateTimeFragment.show(getSupportFragmentManager(), TAG_DATETIME_FRAGMENT);
        //    }
        //});
    }

    @Override
    public void onSaveInstanceState(Bundle savedInstanceState) {
        // Save the current textView
        savedInstanceState.putCharSequence(STATE_TEXTVIEW, textView.getText());

        super.onSaveInstanceState(savedInstanceState);
    }
}
